---
layout: post
title:  "z-methoxy - a cd that remembers"
date: Sun 29 Dec 2024 05:14:52 GMT
---

`z-methoxy` is intended to replace `cd` for tcsh.
After some "training" it cuts down on the number of keystokes
you need to type to move around your filesystem.

Many years ago I heard about autojump, but I could never get it
to work in tcsh. More recently I heard about [`zoxide`](https://github.com/ajeetdsouza/zoxide)
and decided to try that. It turned out that I couldn't get 
`zoxide` to work either.

After watching [Dreams of Autonomy's zoxide video](https://www.youtube.com/watch?v=aghxkpyRVDY&pp=ygUGem94aWRl)
I was convinced enough to write a version myself that worked with tcsh.
Like `zoxide`, `z-methoxy` uses "frecency" (a combination of recency and frequency)
to select the directory from the history.

Then I rewote the program in Rust (because I wanted to learn about Rust) - and this is the result:

[z-methoxy on Github](https://github.com/pemsley/z-methoxy)

There is also a command `cdi` that uses `fzf` for interactive fuzzy finding/search.


